/*  DSBLIB.c   is a collection of small but useful routines for C.
 *  It is not (yet) implemented as a true library.
 */

#ifndef  bool
#include  curses
#endif
#ifndef  EOS
#define  EOS  '\0'
#endif


/*  strsave allocates space the size of max and copies string s to it.
 *  The return value is the pointer to the allocated string.
 *  If max is equal to 0, the length of string s is allocated.
 */
char *
strsave (s, max)
char	*s;
int	max;
{
	register char	*p;
	register char	*q;
	register char	*rs = s;
	char		*malloc();

	if (max==0)  max = strlen(rs) + 1;
	p = q = malloc (max * sizeof(char));
	if (p==NULL)
	    {	fprintf (stderr, "OUT OF STORAGE SPACE -  strsave\n");
		exit (-1);
	    }
	while ((--max) && (*rs))
		*p++ = *rs++;
	*p = EOS;
	return (q);
}
